<?

/*
 ################################################################################
 # IP-Symcon Config-Datei                                                       #
 #                                                                              #
 # Beschreibung : config Datei zu IP-Symcon                                     #
 # Create date  : 2010-11-05                                                    #
 # Last change  : 2010-11-05                                                    #
 # Version      : 0.09                                                          #
 # Datei        : config.class.ips.php                                          #
 # Author       : ernie                                                         #
 # Copyright    : ernie                                                         #
 ################################################################################
 */

namespace de\IPSymcon\ernie;

if (!defined("INCLUDED_DEBUGGER")) {
	DEFINE("INCLUDED_DEBUGGER",TRUE);
	include("../debugger.class.ips.php");
	}

class Config implements EnvironmentDebugger {
	// cAOIDs ok == Object (Variable/Script/Kategorie) bereits in checkAllObjectIDs bercksichtigt
	private $version;
	private $debug;
	private $heizungssteuerung;
	private $ipsConfigObjectIDs;
	
	public function __construct($myVersion) {
		$this->timeBegin = microtime();
		$this->version = $myVersion;
		$this->debug = array();
		$this->debug['showHiddenThings']			= true;
		$this->debug['debugThisSession']			= false;
		$this->debug['showDebugMessageOnEnd']	= false;
		$this->debug['debugWithPRE']				= false;

		$this->debug['disableWarnings']			= false;
		$this->debug['disableOutput']				= false;

		if ($this->debug['disableWarnings']) {
			error_reporting(E_ERROR);
			// alle ohne NOTICE:
			// error_reporting(E_ALL & ~E_NOTICE);
		}

		$this->environmentDebugConfigObject = new EnvironmentDebugObject();

		$do = $this->environmentDebugConfigObject;
		// echo "<PRE>". $this->environmentDebugConfigObject . "</PRE><br>\n";
		// $this->environmentDebugConfigObject->addDebugEnvironment('environmentName',	0,	PRE?,	show Categories?,showCount,	OnEnd,	uesedDebuggers);
		$do->addDebugEnvironment('config.class[getWunschTemperatur]',							0,	TRUE,	TRUE,	FALSE,	FALSE,	DEBUG_MODE_ECHO_LINEBREAK); // maxValue = 1
		$do->addDebugEnvironment('config.class[checkObjectIDExists]',							0,	TRUE,	TRUE,	FALSE,	FALSE,	DEBUG_MODE_ECHO_LINEBREAK); // minValue = 1 / maxValue = 1

		$do->addDebugEnvironment('heizungssteuerung_createHeizplan.class[__construct]',	0,	TRUE,	TRUE,	FALSE,	FALSE,	DEBUG_MODE_ECHO_LINEBREAK); // maxValue = 1
		$do->addDebugEnvironment('heizungssteuerung_createHeizplan.class[initialzing]',	6,	TRUE,	TRUE,	TRUE,		FALSE,	DEBUG_MODE_ECHO_LINEBREAK); // minValue = 7 / maxValue = 9

		$do->addDebugEnvironment('heizungssteuerung_trigger.class[__construct]',			0,	TRUE,	TRUE,	TRUE,		FALSE,	DEBUG_MODE_ECHO_LINEBREAK); // maxValue = 1
		$do->addDebugEnvironment('heizungssteuerung_trigger.class[showActualHeizplan]',	6,	TRUE,	TRUE,	TRUE,		FALSE,	DEBUG_MODE_ECHO_LINEBREAK); // minValue = 7 / maxValue = 9
		$do->addDebugEnvironment('heizungssteuerung_trigger.class[setActualTemperature]',6,	TRUE,	TRUE,	TRUE,		FALSE,	DEBUG_MODE_ECHO_LINEBREAK); // minValue = 7 / maxValue = 9
		$do->addDebugEnvironment('heizungssteuerung_trigger.class[lookOpenWindows]',		6,	TRUE,	TRUE,	TRUE,		FALSE,	DEBUG_MODE_ECHO_LINEBREAK); // minValue = 7 / maxValue = 9
		$do->addDebugEnvironment('heizungssteuerung_trigger.class[setRaumTemperatur]',	4,	TRUE,	TRUE,	TRUE,		FALSE,	DEBUG_MODE_ECHO_LINEBREAK); // minValue = 5 / maxValue = 9
		$do->addDebugEnvironment('heizungssteuerung_trigger.class[SOLL-IST-VERGLEICH]',	6,	TRUE,	TRUE,	TRUE,		FALSE,	DEBUG_MODE_ECHO_LINEBREAK); // minValue = 7 / maxValue = 9
		$do->addDebugEnvironment('heizungssteuerung_trigger.class[lookAllRooms]',			7,	TRUE,	TRUE,	TRUE,		FALSE,	DEBUG_MODE_ECHO_LINEBREAK); // minValue = 8 / maxValue = 9

		$do->addDebugEnvironment('SendeHeizenFloatTemperatur.class[__construct]',						0,	TRUE,	TRUE,	TRUE,		FALSE,	DEBUG_MODE_ECHO_LINEBREAK); // maxValue = 1
		$do->addDebugEnvironment('SendeHeizenFloatTemperatur.class[getSollTemperatur]',				0,	TRUE,	TRUE,	TRUE,		FALSE,	DEBUG_MODE_ECHO_LINEBREAK); // maxValue = 1
		$do->addDebugEnvironment('SendeHeizenFloatTemperatur6und30Grad.class[__construct]',			0,	TRUE,	TRUE,	TRUE,		FALSE,	DEBUG_MODE_ECHO_LINEBREAK); // maxValue = 1
		$do->addDebugEnvironment('SendeHeizenFloatTemperatur6und30Grad.class[getSollTemperatur]',	0,	TRUE,	TRUE,	TRUE,		FALSE,	DEBUG_MODE_ECHO_LINEBREAK); // maxValue = 1
		$do->addDebugEnvironment('SendeHeizenFloatTemperatur6und30Grad.class[setHeizenJaNein]',	8,	TRUE,	TRUE,	TRUE,		FALSE,	DEBUG_MODE_ECHO_LINEBREAK); // minValue = 9 / maxValue = 9
		$do->addDebugEnvironment('SendeHeizenBooleanJaNein.class[__construct]',							0,	TRUE,	TRUE,	TRUE,		FALSE,	DEBUG_MODE_ECHO_LINEBREAK); // maxValue = 1
		$do->addDebugEnvironment('SendeHeizenBooleanJaNein.class[getSollTemperatur]',					0,	TRUE,	TRUE,	TRUE,		FALSE,	DEBUG_MODE_ECHO_LINEBREAK); // maxValue = 1
		$do->addDebugEnvironment('SendeHeizenBooleanJaNein.class[setHeizenJaNein]',					0,	TRUE,	TRUE,	TRUE,		FALSE,	DEBUG_MODE_ECHO_LINEBREAK); // minValue = 9 / maxValue = 9

		// ##################################################
		// ###
		// ### DEFINE Heizungssteuerung
		// ###
		$this->heizungssteuerung = array();

		// ### Definition, aus welchem Interface
		// ### das Heizungs-Komponenten erstellt werden soll?
		// ### Aktuell implementierte Interfaces:
		// ###    - sendeHeizenFloatTemperatur (ehemals HomeMaticKomponenten)
		// ###    - sendeHeizenFloatTemperatur6und30Grad (ehemals HomeMaticKomponentenHeizenJaNein)
		// ###    - sendeHeizenBooleanJaNein (ehemals EinsWireWagoKombinationsKomponenten)
		// ### Aktuell implementierte heizungsKomponenten (NUR BEI heizungsInterface sendeHeizenFloatTemperatur):
		// ###    - HomeMatic
		// ###    - FS20
		// ### LAST CHANGE IN IN REVISION 3.5
		// ### Test-Szenario CHANGE CHANGE CHANGE 1/3
		// $this->heizungssteuerung['heizungsKomponenten'] = "EinsWireWagoKombinationsKomponenten";
		$this->heizungssteuerung['heizungsInterface'] = "sendeHeizenFloatTemperatur6und30Grad";
		$this->heizungssteuerung['heizungsKomponenten'] = "";

		// ### Definition der createHeizplan Konstanten, u.a.
		// ###   - ObjectID des ChangeBoolean Scripts, dass im WebFront die Anwesend/Abwesend der Variablen tooglet
		// ###   - Konstanten fr die CustomProfiles, die den An- und Abwesenheitsvariablen zugeweisen werden
		// ###   - Auswahl, ob die Heizplan Variablen (An- und Abwesenenheit) fr das iFront
		// ###		- gekrzt werden sollen (ohne Bezeichner "Mittags / Abends)
		// ###		- das CustomProfile (~Switch oder b_Anwesend-Abwesend) fr einen Toogle-Button hinterlegt bekommen
		// ###         - b_Anwesend-Abwesend: Die Variablen im WebFront sind grn und rot und haben den Bezeichner
		// ###           "Anwesend" und "Abwesend" im iFront muss man ins Untermen wechseln, um Sie umzuschalten
		// ###         - ~Switch: Die Variablen im WebFront sind grn und rot und haben den Bezeichner
		// ###           "An" und "Aus" im iFront kann man diese per Toogle Button direkt umschalten
		// ### LAST CHANGE IN IN REVISION 3
		$this->heizungssteuerung['createHeizplanConstants'] = array();
		$this->heizungssteuerung['createHeizplanConstants']['WebFrontChangeVariableScriptObjectID']	= 54305; // cAOIDs ok
		$this->heizungssteuerung['createHeizplanConstants']['WebFrontVariableProfileName'] 				= "b_Anwesend-Abwesend"; 	// cAOIDs ok
		// $this->heizungssteuerung['createHeizplanConstants']['WebFrontWunschTempeaturProfileName'] = "f_Raumtempperatur";     // wird nur manuell den Wunsch-Temperatur Variablen zugewiesen
		$this->heizungssteuerung['createHeizplanConstants']['iFrontVariableProfileName'] 				= "~Switch"; 					// cAOIDs ok
		$this->heizungssteuerung['createHeizplanConstants']['CreateShortHeizplanVariablen'] 			= TRUE;
		$this->heizungssteuerung['createHeizplanConstants']['CreateiFrontToogleButton'] 					= TRUE;
		$this->heizungssteuerung['createHeizplanConstants']['IPSCreateVariableBoolean'] 					= 0;
		$this->heizungssteuerung['createHeizplanConstants']['IPSCreateVariableInteger'] 					= 1;
		$this->heizungssteuerung['createHeizplanConstants']['IPSCreateVariableFloat'] 					= 2;
		$this->heizungssteuerung['createHeizplanConstants']['IPSCreateVariableString'] 					= 3;

		// ### Definition der ObjectIDs der Kategorien, in denen der Heizplan
		// ### der einzelnen Tage erstellt werden soll
		// ### LAST CHANGE IN IN REVISION 1
		$this->heizungssteuerung['rootNodesHeizplan'] = array();
		// for testing:
		// $this->heizungssteuerung['rootNodesHeizplan'][0] = 39943; // cAOIDs ok
		$this->heizungssteuerung['rootNodesHeizplan'][1] = 39943; // cAOIDs ok 
		$this->heizungssteuerung['rootNodesHeizplan'][2] = 33124; // cAOIDs ok 
		$this->heizungssteuerung['rootNodesHeizplan'][3] = 45034; // cAOIDs ok 
		$this->heizungssteuerung['rootNodesHeizplan'][4] = 24413; // cAOIDs ok 
		$this->heizungssteuerung['rootNodesHeizplan'][5] = 42431; // cAOIDs ok 
		$this->heizungssteuerung['rootNodesHeizplan'][6] = 17169; // cAOIDs ok 
		$this->heizungssteuerung['rootNodesHeizplan'][7] = 24282; // cAOIDs ok 

		// ###
		// ### Definition der ObjectIDs, an denen die Raum-Soll-Temperaturen gelesen werden knnen
		// ###    bei HomeMatic muss hier die SETPOINT Variable der Thermostate verlinkt werden
		// ###    bei 1-Wire in IPS selbst definierte Variablen
		// ### LAST CHANGE IN IN REVISION 3
		$this->heizungssteuerung['readRaumSollTemeratur'] = array();
		// ### Entweder direkte Thermostate
		// ###    bei HomeMatic
		$this->heizungssteuerung['readRaumSollTemeratur']['Bad'] 			= 11496; // cAOIDs ok  //[Heizung\HomeMatic Komponenten\Bad\Bad - Thermostat - Klima (CLIMATECONTROL_REGULATOR)\SETPOINT]
		$this->heizungssteuerung['readRaumSollTemeratur']['Bro']			= 57653; // cAOIDs ok  //[Heizung\HomeMatic Komponenten\Bro\Bro - Thermostat - Klima (CLIMATECONTROL_REGULATOR)\SETPOINT]
		$this->heizungssteuerung['readRaumSollTemeratur']['Kinderzimmer'] = 54771; // cAOIDs ok  //[Heizung\HomeMatic Komponenten\Gstezimmer\Gstezimmer - Thermostat - Klima (CLIMATECONTROL_REGULATOR)\SETPOINT]
		$this->heizungssteuerung['readRaumSollTemeratur']['Schlafzimmer'] = 53751; // cAOIDs ok  //[Heizung\HomeMatic Komponenten\Schlafzimmer\Schlafzimmer - Thermostat - Klima (CLIMATECONTROL_REGULATOR)\SETPOINT]
		$this->heizungssteuerung['readRaumSollTemeratur']['Wohnzimmer'] 	= 50601; // cAOIDs ok  //[Heizung\HomeMatic Komponenten\Wohnzimmer\Wohnzimmer - Thermostat - Klima (CLIMATECONTROL_REGULATOR)\SETPOINT]
		// ### ODER IPS-Variablen (zum speichern und lesen der Werte)
		// ### (diese mssen im IPS-Baum selbst angelegt werden)
		// ###    z.B. bei 1-wire Modulen
		// ###    z.B. bei HomeMaticHeizenJaNein
		// ### Test-Szenario CHANGE CHANGE CHANGE 2/3
		$this->heizungssteuerung['readRaumSollTemeratur']['Bad'] 			= 42715; // cAOIDs ok  //[Heizung\Heizungssteuerung\heiz - Soll Temperaturen\Bad]
		$this->heizungssteuerung['readRaumSollTemeratur']['Bro']			= 57644; // cAOIDs ok  //[Heizung\Heizungssteuerung\heiz - Soll Temperaturen\Bro]
		$this->heizungssteuerung['readRaumSollTemeratur']['Kinderzimmer']	= 26155; // cAOIDs ok  //[Heizung\Heizungssteuerung\heiz - Soll Temperaturen\Kinderzimmer]
		$this->heizungssteuerung['readRaumSollTemeratur']['Schlafzimmer'] = 35587; // cAOIDs ok  //[Heizung\Heizungssteuerung\heiz - Soll Temperaturen\Schlafzimmer]
		$this->heizungssteuerung['readRaumSollTemeratur']['Wohnzimmer'] 	= 53457; // cAOIDs ok  //[Heizung\Heizungssteuerung\heiz - Soll Temperaturen\Wohnzimmer]

		// ###
		// ### Definition der ObjectIDs an denen die Raum-Soll-Temperaturen geschrieben werden knnen
		// ### Eventuell sind diese gleich "Gelesenen", bei HomeMatic jedoch nicht ...
		// ### dort wird die Variable ausgelsen, jedoch ins Thermostat zurckgeschrieben
		// ### LAST CHANGE IN IN REVISION 3
		// ### Entweder direkte Thermostate
		// ###    bei HomeMatic
		$this->heizungssteuerung['writeRaumSollTemeratur'] = array();
		$this->heizungssteuerung['writeRaumSollTemeratur']['Bad'] 				= 36797; // cAOIDs ok ;
		$this->heizungssteuerung['writeRaumSollTemeratur']['Bro']				= 19315; // cAOIDs ok ;
		$this->heizungssteuerung['writeRaumSollTemeratur']['Kinderzimmer'] 	= 31325; // cAOIDs ok ;
		$this->heizungssteuerung['writeRaumSollTemeratur']['Schlafzimmer'] 	= 30084; // cAOIDs ok ;
		$this->heizungssteuerung['writeRaumSollTemeratur']['Wohnzimmer'] 		= 42515; // cAOIDs ok ;
		// ### ODER IPS-Variablen (zum speichern und lesen der Werte)
		// ### (diese mssen im IPS-Baum selbst angelegt werden)
		// ###    z.B. bei 1-wire Modulen
		/*
		$this->heizungssteuerung['writeRaumSollTemeratur']['Bad'] 				= 42715; // cAOIDs ok //[Heizung\Heizungssteuerung\heiz - Soll Temperaturen\Bad]
		$this->heizungssteuerung['writeRaumSollTemeratur']['Bro']				= 57644; // cAOIDs ok //[Heizung\Heizungssteuerung\heiz - Soll Temperaturen\Bro]
		$this->heizungssteuerung['writeRaumSollTemeratur']['Kinderzimmer'] 	= 26155; // cAOIDs ok //[Heizung\Heizungssteuerung\heiz - Soll Temperaturen\Kinderzimmer]
		$this->heizungssteuerung['writeRaumSollTemeratur']['Schlafzimmer'] 	= 35587; // cAOIDs ok //[Heizung\Heizungssteuerung\heiz - Soll Temperaturen\Schlafzimmer]
		$this->heizungssteuerung['writeRaumSollTemeratur']['Wohnzimmer'] 		= 53457; // cAOIDs ok //[Heizung\Heizungssteuerung\heiz - Soll Temperaturen\Wohnzimmer]
		*/

		// ###
		// ### Definition der ObjectIDs, an denen die Raum-Ist-Temperaturen gelesen werden knnen
		// ### LAST CHANGE IN IN REVISION 2
		// ### Entweder direkte Thermostate
		// ###    bei HomeMatic
		$this->heizungssteuerung['readRaumIstTemeratur'] = array();
		$this->heizungssteuerung['readRaumIstTemeratur']['Bad'] 				= 30941; // cAOIDs ok
		$this->heizungssteuerung['readRaumIstTemeratur']['Bro']				= 39080; // cAOIDs ok
		$this->heizungssteuerung['readRaumIstTemeratur']['Kinderzimmer'] 	= 47279; // cAOIDs ok
		$this->heizungssteuerung['readRaumIstTemeratur']['Schlafzimmer'] 	= 25826; // cAOIDs ok
		$this->heizungssteuerung['readRaumIstTemeratur']['Wohnzimmer'] 	= 10100; // cAOIDs ok

		// ###
		// ### Definition der ObjectIDs, an denen die Heiz-Stati der Rume gelesen werden knnen
		// ### Diese ObjectIDs mssen nur definiert werden, wenn das Interface entweder
		// ### HomeMaticHeizenJaNein oder EinsWireWagoKombinationsKomponenten ist
		// ### LAST CHANGE IN IN REVISION 3
		$this->heizungssteuerung['heizStatiRaeume'] = array();
		$this->heizungssteuerung['heizStatiRaeume']['Bad'] 				= 52917; // cAOIDs ok
		$this->heizungssteuerung['heizStatiRaeume']['Bro']				= 46508; // cAOIDs ok
		$this->heizungssteuerung['heizStatiRaeume']['Kinderzimmer'] 	= 31397; // cAOIDs ok
		$this->heizungssteuerung['heizStatiRaeume']['Schlafzimmer'] 	= 54207; // cAOIDs ok
		$this->heizungssteuerung['heizStatiRaeume']['Wohnzimmer'] 		= 46096; // cAOIDs ok

		// ###
		// ### Definition der ObjectIDs der Fenster-Kontakte
		// ### LAST CHANGE IN IN REVISION 2
		$this->heizungssteuerung['rootNodesFenster'] = array();
		$this->heizungssteuerung['rootNodesFenster']['Bad'] = array();
		$this->heizungssteuerung['rootNodesFenster']['Bad'][0] 				= 58608; // cAOIDs ok

		// ###
		// ### Definition der ObjectIDs der IPS-Variablen, aus denen
		// ### die An-/Abwesend Wunsch-Temperaturen ausgelesen werden soll
		// ### Dort sollten FLOAT Variablen erstellt werden
		// LAST CHANGE IN IN REVISION 2
		$this->heizungssteuerung['temperaturProfile'] = array();
		$this->heizungssteuerung['temperaturProfile']['Bad'] = array();
		$this->heizungssteuerung['temperaturProfile']['Bad']['Anwesend'] 				= 14291; // cAOIDs ok
		$this->heizungssteuerung['temperaturProfile']['Bad']['Abwesend'] 				= 17837; // cAOIDs ok
		$this->heizungssteuerung['temperaturProfile']['Bro'] = array();
		$this->heizungssteuerung['temperaturProfile']['Bro']['Anwesend'] 			= 23609; // cAOIDs ok
		$this->heizungssteuerung['temperaturProfile']['Bro']['Abwesend'] 			= 25567; // cAOIDs ok
		$this->heizungssteuerung['temperaturProfile']['Kinderzimmer'] = array();
		$this->heizungssteuerung['temperaturProfile']['Kinderzimmer']['Anwesend'] 	= 16056; // cAOIDs ok
		$this->heizungssteuerung['temperaturProfile']['Kinderzimmer']['Abwesend'] 	= 32661; // cAOIDs ok
		$this->heizungssteuerung['temperaturProfile']['Schlafzimmer'] = array();
		$this->heizungssteuerung['temperaturProfile']['Schlafzimmer']['Anwesend'] 	= 20055; // cAOIDs ok
		$this->heizungssteuerung['temperaturProfile']['Schlafzimmer']['Abwesend'] 	= 18066; // cAOIDs ok
		$this->heizungssteuerung['temperaturProfile']['Wohnzimmer'] = array();
		$this->heizungssteuerung['temperaturProfile']['Wohnzimmer']['Anwesend'] 	= 24623; // cAOIDs ok
		$this->heizungssteuerung['temperaturProfile']['Wohnzimmer']['Abwesend'] 	= 10409; // cAOIDs ok

		// ###
		// ### Definition der Zeit- und Standard-Anwesenheits-Profilen
		// ### inkl. der Aufteilung nach Wochentag / Wochenende
		// ### LAST CHANGE IN IN REVISION 1
		$this->heizungssteuerung['zeitProfile'] = array();
		$this->heizungssteuerung['standardZuordnung'] = array();

		// ### Raum Definitionen - Bad
		$this->heizungssteuerung['zeitProfile']['Bad'] = array();
		$this->heizungssteuerung['zeitProfile']['Bad'][0] = "06:00 bis 07:00 Uhr - Frhmorgens";
		$this->heizungssteuerung['zeitProfile']['Bad'][1] = "07:00 bis 09:00 Uhr - Morgens";
		$this->heizungssteuerung['zeitProfile']['Bad'][2] = "09:00 bis 10:30 Uhr - Sptmorgens";
		$this->heizungssteuerung['zeitProfile']['Bad'][3] = "10:30 bis 21:00 Uhr - Tagsber";
		$this->heizungssteuerung['zeitProfile']['Bad'][4] = "21:00 bis 23:00 Uhr - Sptabends";
		$this->heizungssteuerung['standardZuordnung']['Bad'] = array();
		$this->heizungssteuerung['standardZuordnung']['Bad']['Werktags'] = array();
		$this->heizungssteuerung['standardZuordnung']['Bad']['Wochenende'] = array();
		$this->heizungssteuerung['standardZuordnung']['Bad']['Werktags']["06:00 bis 07:00 Uhr - Frhmorgens"] 	= TRUE;
		$this->heizungssteuerung['standardZuordnung']['Bad']['Werktags']["07:00 bis 09:00 Uhr - Morgens"] 			= FALSE;
		$this->heizungssteuerung['standardZuordnung']['Bad']['Werktags']["09:00 bis 10:30 Uhr - Sptmorgens"] 	= TRUE;
		$this->heizungssteuerung['standardZuordnung']['Bad']['Werktags']["10:30 bis 21:00 Uhr - Tagsber"] 		= FALSE;
		$this->heizungssteuerung['standardZuordnung']['Bad']['Werktags']["21:00 bis 23:00 Uhr - Sptabends"] 		= TRUE;
		$this->heizungssteuerung['standardZuordnung']['Bad']['Wochenende']["06:00 bis 07:00 Uhr - Frhmorgens"] 	= TRUE;
		$this->heizungssteuerung['standardZuordnung']['Bad']['Wochenende']["07:00 bis 09:00 Uhr - Morgens"] 		= FALSE;
		$this->heizungssteuerung['standardZuordnung']['Bad']['Wochenende']["09:00 bis 10:30 Uhr - Sptmorgens"] 	= TRUE;
		$this->heizungssteuerung['standardZuordnung']['Bad']['Wochenende']["10:30 bis 21:00 Uhr - Tagsber"] 		= FALSE;
		$this->heizungssteuerung['standardZuordnung']['Bad']['Wochenende']["21:00 bis 23:00 Uhr - Sptabends"] 	= TRUE;

		// ### Raum Definitionen - Bro
		$this->heizungssteuerung['zeitProfile']['Bro'] = array();
		$this->heizungssteuerung['zeitProfile']['Bro'][0] = "06:00 bis 12:00 Uhr - Morgens";
		$this->heizungssteuerung['zeitProfile']['Bro'][1] = "12:00 bis 16:00 Uhr - Tagsber";
		$this->heizungssteuerung['zeitProfile']['Bro'][2] = "16:00 bis 19:30 Uhr - Nachmittags";
		$this->heizungssteuerung['zeitProfile']['Bro'][3] = "19:30 bis 23:00 Uhr - Abends";
		$this->heizungssteuerung['standardZuordnung']['Bro'] = array();
		$this->heizungssteuerung['standardZuordnung']['Bro']['Werktags'] = array();
		$this->heizungssteuerung['standardZuordnung']['Bro']['Wochenende'] = array();
		$this->heizungssteuerung['standardZuordnung']['Bro']['Werktags']["06:00 bis 12:00 Uhr - Morgens"] 		= FALSE;
		$this->heizungssteuerung['standardZuordnung']['Bro']['Werktags']["12:00 bis 16:00 Uhr - Tagsber"] 		= FALSE;
		$this->heizungssteuerung['standardZuordnung']['Bro']['Werktags']["16:00 bis 19:30 Uhr - Nachmittags"] 	= FALSE;
		$this->heizungssteuerung['standardZuordnung']['Bro']['Werktags']["19:30 bis 23:00 Uhr - Abends"] 			= FALSE;
		$this->heizungssteuerung['standardZuordnung']['Bro']['Wochenende']["06:00 bis 12:00 Uhr - Morgens"] 		= FALSE;
		$this->heizungssteuerung['standardZuordnung']['Bro']['Wochenende']["12:00 bis 16:00 Uhr - Tagsber"] 	= FALSE;
		$this->heizungssteuerung['standardZuordnung']['Bro']['Wochenende']["16:00 bis 19:30 Uhr - Nachmittags"] = FALSE;
		$this->heizungssteuerung['standardZuordnung']['Bro']['Wochenende']["19:30 bis 23:00 Uhr - Abends"] 		= FALSE;

		// ### Raum Definitionen - Kinderzimmer
		$this->heizungssteuerung['zeitProfile']['Kinderzimmer'] = array();
		$this->heizungssteuerung['zeitProfile']['Kinderzimmer'][0] = "08:00 bis 10:00 Uhr - Morgens";
		$this->heizungssteuerung['zeitProfile']['Kinderzimmer'][1] = "10:00 bis 21:00 Uhr - Tagsber";
		$this->heizungssteuerung['zeitProfile']['Kinderzimmer'][2] = "21:00 bis 22:00 Uhr - Abends";
		$this->heizungssteuerung['standardZuordnung']['Kinderzimmer'] = array();
		$this->heizungssteuerung['standardZuordnung']['Kinderzimmer']['Werktags'] = array();
		$this->heizungssteuerung['standardZuordnung']['Kinderzimmer']['Wochenende'] = array();
		$this->heizungssteuerung['standardZuordnung']['Kinderzimmer']['Werktags']["08:00 bis 10:00 Uhr - Morgens"] 		= TRUE;
		$this->heizungssteuerung['standardZuordnung']['Kinderzimmer']['Werktags']["10:00 bis 21:00 Uhr - Tagsber"] 	= FALSE;
		$this->heizungssteuerung['standardZuordnung']['Kinderzimmer']['Werktags']["21:00 bis 22:00 Uhr - Abends"] 		= TRUE;
		$this->heizungssteuerung['standardZuordnung']['Kinderzimmer']['Wochenende']["08:00 bis 10:00 Uhr - Morgens"] 	= TRUE;
		$this->heizungssteuerung['standardZuordnung']['Kinderzimmer']['Wochenende']["10:00 bis 21:00 Uhr - Tagsber"] 	= FALSE;
		$this->heizungssteuerung['standardZuordnung']['Kinderzimmer']['Wochenende']["21:00 bis 22:00 Uhr - Abends"] 	= TRUE;

		// ### Raum Definitionen - Schlafzimmer
		$this->heizungssteuerung['zeitProfile']['Schlafzimmer'] = array();
		$this->heizungssteuerung['zeitProfile']['Schlafzimmer'][0] = "07:00 bis 19:00 Uhr - Tagsber";
		$this->heizungssteuerung['zeitProfile']['Schlafzimmer'][1] = "19:00 bis 22:00 Uhr - Abends";
		$this->heizungssteuerung['zeitProfile']['Schlafzimmer'][2] = "22:00 bis 23:59 Uhr - Nachts";
		$this->heizungssteuerung['standardZuordnung']['Schlafzimmer'] = array();
		$this->heizungssteuerung['standardZuordnung']['Schlafzimmer']['Werktags'] = array();
		$this->heizungssteuerung['standardZuordnung']['Schlafzimmer']['Wochenende'] = array();
		$this->heizungssteuerung['standardZuordnung']['Schlafzimmer']['Werktags']["07:00 bis 19:00 Uhr - Tagsber"] 	= FALSE;
		$this->heizungssteuerung['standardZuordnung']['Schlafzimmer']['Werktags']["19:00 bis 22:00 Uhr - Abends"] 		= FALSE;
		$this->heizungssteuerung['standardZuordnung']['Schlafzimmer']['Werktags']["22:00 bis 23:59 Uhr - Nachts"] 		= FALSE;
		$this->heizungssteuerung['standardZuordnung']['Schlafzimmer']['Wochenende']["07:00 bis 19:00 Uhr - Tagsber"] 	= FALSE;
		$this->heizungssteuerung['standardZuordnung']['Schlafzimmer']['Wochenende']["19:00 bis 22:00 Uhr - Abends"] 	= FALSE;
		$this->heizungssteuerung['standardZuordnung']['Schlafzimmer']['Wochenende']["22:00 bis 23:59 Uhr - Nachts"] 	= FALSE;

		// ### Raum Definitionen - Wohnzimmer
		$this->heizungssteuerung['zeitProfile']['Wohnzimmer'] = array();
		$this->heizungssteuerung['zeitProfile']['Wohnzimmer'][0] = "07:00 bis 10:00 Uhr - Morgens";
		$this->heizungssteuerung['zeitProfile']['Wohnzimmer'][1] = "10:00 bis 13:00 Uhr - Sptmorgens";
		$this->heizungssteuerung['zeitProfile']['Wohnzimmer'][2] = "13:00 bis 19:00 Uhr - Tagsber";
		$this->heizungssteuerung['zeitProfile']['Wohnzimmer'][3] = "19:00 bis 23:00 Uhr - Abends";
		$this->heizungssteuerung['standardZuordnung']['Wohnzimmer'] = array();
		$this->heizungssteuerung['standardZuordnung']['Wohnzimmer']['Werktags'] = array();
		$this->heizungssteuerung['standardZuordnung']['Wohnzimmer']['Wochenende'] = array();
		$this->heizungssteuerung['standardZuordnung']['Wohnzimmer']['Werktags']["07:00 bis 10:00 Uhr - Morgens"] 		= TRUE;
		$this->heizungssteuerung['standardZuordnung']['Wohnzimmer']['Werktags']["10:00 bis 13:00 Uhr - Sptmorgens"] 	= FALSE;
		$this->heizungssteuerung['standardZuordnung']['Wohnzimmer']['Werktags']["13:00 bis 19:00 Uhr - Tagsber"] 		= FALSE;
		$this->heizungssteuerung['standardZuordnung']['Wohnzimmer']['Werktags']["19:00 bis 23:00 Uhr - Abends"] 			= TRUE;
		$this->heizungssteuerung['standardZuordnung']['Wohnzimmer']['Wochenende']["07:00 bis 10:00 Uhr - Morgens"] 		= TRUE;
		$this->heizungssteuerung['standardZuordnung']['Wohnzimmer']['Wochenende']["10:00 bis 13:00 Uhr - Sptmorgens"] = FALSE;
		$this->heizungssteuerung['standardZuordnung']['Wohnzimmer']['Wochenende']["13:00 bis 19:00 Uhr - Tagsber"] 	= FALSE;
		$this->heizungssteuerung['standardZuordnung']['Wohnzimmer']['Wochenende']["19:00 bis 23:00 Uhr - Abends"] 		= TRUE;

		// ############################################################################################
		// ###
		// ### Raum-Steuerungstechniken definieren:
		// ###
		// ### KEINE Erweiterte Raum-Steuerungstechnik
		// ###    Das Raum-Thermostat wird einfach auf die Wunsch-Temperatur gesetzt
		// ###
		// ### SIMPLE-DELTA Raumsteuerungstechnik
		// ###    Da einige Systeme den Raum hher heizen als gewnscht, kann
		// ###    hier ein DELTA-Wert angegeben werden, der auf von allen
		// ###    Wunsch-Temperaturen abgezogen wird
		// ###
		// ### SOLL-IST-VERGLEICH Raumsteuerungstechnik
		// ###    Sollte das Thermostat nur Heizen Ja/Nein untersttzen
		// ###    oder die Thermostatssteuerung zu schlecht sein, kann mit
		// ###    dieser Steuerungstechnik die Soll Temperatur permanent mit
		// ###    der Ist-Temperatur verglichen und angepasst werden
		// ###    Solange die Wunsch-Temperatur plus die Delta-Temperatur im
		// ###    Raum noch nicht erreicht ist, wird diese als Soll-Temperatur gesetzt
		// ###    Wenn diese Temperatur erreicht ist, wird die Soll-Temperatur auf die
		// ###    Wunsch-Temperatur minus die Delta-Temperatur gesetzt.
		// ###    Dies gilt so lange, bis die Ist-Temperatur diese neue
		// ###    Soll-Temperatur unterschreitet
		// ###
		// ###    Eventuelle DELTA-Werte aus SIMPLE-DELTA werden auch hier beachtet
		// ###
		// ### BERSCHWAPPT-DELTA Raumstuuerungstechik (aktuell noch NICHT implementiert)
		// ###    Hier der Raum erst auf die Wunsch-Temperatur minus den jeweiligen Delta Wert
		// ###    hochheizt. Dann wird die tatschliche Wunsch-Temperatur gesetzt.
		// ###    Damit soll verhindert werden, dass die Raumtemperatur "berschwappt" bevor sich die
		// ###    Stellantriebe bei der Wunsch-Temperatur schlieen
		// ###
		// ###    Eventuelle DELTA-Werte aus SIMPLE-DELTA werden auch hier beachtet

		// Welche Technik soll fr welchen Raum benutzt werden?
		// LAST CHANGE IN REVISION 3
		$this->heizungssteuerung['raumSteuerungsTechnik'] = array();
		$this->heizungssteuerung['raumSteuerungsTechnik']['Bad'] 			= "SIMPLE-DELTA";
		$this->heizungssteuerung['raumSteuerungsTechnik']['Bro'] 			= "KEINE";
		$this->heizungssteuerung['raumSteuerungsTechnik']['Kinderzimmer']	= "SIMPLE-DELTA";
		$this->heizungssteuerung['raumSteuerungsTechnik']['Wohnzimmer'] 	= "SIMPLE-DELTA";
		$this->heizungssteuerung['raumSteuerungsTechnik']['Schlafzimmer']	= "SIMPLE-DELTA";
		// ### Test-Szenario CHANGE CHANGE CHANGE 3/3
		$this->heizungssteuerung['raumSteuerungsTechnik']['Bad'] 			= "SOLL-IST-VERGLEICH";
		$this->heizungssteuerung['raumSteuerungsTechnik']['Bro'] 			= "SOLL-IST-VERGLEICH";
		$this->heizungssteuerung['raumSteuerungsTechnik']['Kinderzimmer']	= "SOLL-IST-VERGLEICH";
		$this->heizungssteuerung['raumSteuerungsTechnik']['Wohnzimmer'] 	= "SOLL-IST-VERGLEICH";
		$this->heizungssteuerung['raumSteuerungsTechnik']['Schlafzimmer']	= "SOLL-IST-VERGLEICH";

		// Delta Werte, die beim "Hochheizen" eines Raumes vorerst von der Wunsch-Temperatur
		// abgezogen werden, bis die Wunsch-Temperatur minus Delta erreicht wird

		// SIMPLE-DELTA Werte definieren
		// Delta Werte, die fr die Soll-Temperatur des Raumes abgezogen wird
		// Die Werte gelten fr das
		//    - SIMPLE-DELTA und
		//    - SOLL-IST-VERGLEICH (wie viel mehr wird ein Raum auf bzw. abgezeigt,
		//
		// Steuerungstechnik (siehe obige Erklrung)
		// Die Werte drfen nicht zuindest bei SOLL-IST-VERGLEICH NICHT 0 sein,
		// da ansonsten die Heiz und Abkhl-Temperatur gleich ist,
		// was Fehler in der Steuerung verursacht
		// TODO: am Anfang abprfen, ob die Werte 0 sind (in checkAllObjectIDs)
		// LAST CHANGE IN REVISION 2
		$this->heizungssteuerung['simpleDeltaTemperatur'] = array();
		$this->heizungssteuerung['simpleDeltaTemperatur']['Bad'] 			=  0.5;
		$this->heizungssteuerung['simpleDeltaTemperatur']['Bro'] 			=  0.5;
		$this->heizungssteuerung['simpleDeltaTemperatur']['Kinderzimmer']	=  0.5;
		$this->heizungssteuerung['simpleDeltaTemperatur']['Schlafzimmer']	=  0.5;
		$this->heizungssteuerung['simpleDeltaTemperatur']['Wohnzimmer'] 	=  0.5;

		// BERSCHWAPP-DELTA Raum-Steuerungs-Definitionen
		/*
	   // TODO: in config verschieben?
	   // berschwappt-Abrechnungs-Delta
		// ist die Abrechnungs-Wert in %,
		// bei der der Raum auf die eigentliche Wunsch-Temperatur angehoben wird
	   // Beispiele:
	   //    - Wunsch-Temperatur = 18
	   //    - DeltaWert: 2 ==> Anheiz-Temperatur == 16 (18 - 2)
	   //
	   // 0    bedeutet, dass bei einer IST-Temperatur von 18,0 (18 - 0,0 /  0% von 2)
		//      die SOLL-Temperatur von 16 Anheizen auf 18 angehoben wird
		// 0.25 bedeutet, dass bei einer IST-Temperatur von 17,5 (18 - 0,5 / 25% von 2)
		//      die SOLL-Temperatur von 16 Anheizen auf 18 angehoben wird
	   // 1    bedeutet, dass bei einer IST-Temperatur von 16,0 (18 - 2,0 / 100% von 2)
		//      die SOLL-Temperatur von 16 Anheizen auf 18 angehoben wird
		$ueberschwapptDelta = 0.25;
		==> fr jeden Raum einzeln
		*/

		// ###
		// ### END DEFINE Heizungssteuerung
		// ###
		// ##############################################################

		// define other things
		$this->diverses = array();
		$this->diverses['newLine'] 					= "<br>\n";
		$this->diverses['newDebugLine'] 			= "\n";
		$this->diverses['HTMLDebugPlaceHolder'] 	= "&nbsp;&nbsp;&nbsp;";

		$this->diverses['color[black]'] 		= "#000000";
		$this->diverses['color[green]']		= "#009900";
		$this->diverses['color[red]'] 		= "#FF0000";
		$this->diverses['color[winered]']	= "#990000";
		$this->diverses['color[yellow]']		= "#FFFFCC";
	}

	public function getVersion() {
		return $this->version;
	}

	public function getCreateHeizplanConfigConstantsArray() {
		return $this->heizungssteuerung['createHeizplanConstants'];
	}

	public function getHeizungsKomponenten() {
		return $this->heizungssteuerung['heizungsKomponenten'];
	}

	public function getHeizungsInterface() {
		return $this->heizungssteuerung['heizungsInterface'];
	}

	public function getWindowRootNodeForRoom($roomName) {
	   // returns Array, falls Fenster fr den Raum existieren
	   // returns -1, falls keine Fenster existieren
		if (isset($this->heizungssteuerung['rootNodesFenster'][$roomName])) {
			return $this->heizungssteuerung['rootNodesFenster'][$roomName];
		}
		else {
		   return -1;
		}
	}
	
	public function getRootNodeForDay($dayNumber) {
	   // 1 = Montag; 7 = Sonntag
		return $this->heizungssteuerung['rootNodesHeizplan'][$dayNumber];
	}

	public function getObjectIDRaumHeizStatus($raumName) {
		return $this->heizungssteuerung['heizStatiRaeume'][$raumName];
	}

	public function getReadRaumSollTemperaturObjectID($raumName) {
		return $this->heizungssteuerung['readRaumSollTemeratur'][$raumName];
	}

	public function getRaumIstTemperatur($raumName) {
		return GetValueFloat($this->heizungssteuerung['readRaumIstTemeratur'][$raumName]);
	}

	public function getRaumSteuerungsTechnik($raumName) {
		return $this->heizungssteuerung['raumSteuerungsTechnik'][$raumName];
	}

	public function getSimpleDeltaTemperaturRaum($raumName) {
		return $this->heizungssteuerung['simpleDeltaTemperatur'][$raumName];
	}

	public function getWriteRaumSollTemperaturObjectID($raumName) {
		return $this->heizungssteuerung['writeRaumSollTemeratur'][$raumName];
	}

	public function getWunschTemperatur($raumName,$anwesenheit) {
	   $anwesenheitString = "";
		if ($anwesenheit) {$anwesenheitString = "Anwesend";}
		else {$anwesenheitString = "Abwesend";}
		$this->showEnvironmentDebugMessage('call getWunschTemperatur('. $raumName .','. $anwesenheitString .')' ,"config.class[getWunschTemperatur]",1);
		$result = GetValueFloat($this->heizungssteuerung['temperaturProfile'][$raumName][$anwesenheitString]);
		$this->showEnvironmentDebugMessage('   $result == '. $result ,"config.class[getWunschTemperatur]",1);
		return $result;
	}

	public function getZeitProfile() {
		return $this->heizungssteuerung['zeitProfile'];
	}

	public function getTemperaturProfile() {
		return $this->heizungssteuerung['temperaturProfile'];
	}

	public function getStandardZuordnung() {
		return $this->heizungssteuerung['standardZuordnung'];
	}

	public function getInitialAnwesendValue($raumName,$zeit,$actualWeekDay) {
		// $this->showEnvironmentDebugMessage('call getInitialAnwesendValue('. $raumName .','. $anwesenheit .')' ,"config.class[getWunschTemperatur]",1);
		// $this->configObject->showEnvironmentDebugMessage('   $result == '. $result ,"homeMaticKomponenten.class[getSollTemperatur]",1);
		if ($actualWeekDay <= 5) {
		   return $this->heizungssteuerung['standardZuordnung'][$raumName]['Werktags'][$zeit];
	   }
		else {
		   return $this->heizungssteuerung['standardZuordnung'][$raumName]['Wochenende'][$zeit];
		}
	}

	 public function checkAllObjectIDs () {
	 	// Alle ObjectIDs fr IPS Variablen durchgehen, ob dort auch Variablen existieren?
	 	$this->checkObjectIDExists("script",$this->heizungssteuerung['createHeizplanConstants']['WebFrontChangeVariableScriptObjectID'],'$this->heizungssteuerung["createHeizplanConstants"]["WebFrontChangeVariableScriptObjectID"]');
	 	$this->checkObjectIDExists("variableProfile",$this->heizungssteuerung['createHeizplanConstants']['WebFrontVariableProfileName'],'$this->heizungssteuerung["createHeizplanConstants"]["WebFrontVariableProfileName"]');
	 	$this->checkObjectIDExists("variableProfile",$this->heizungssteuerung['createHeizplanConstants']['iFrontVariableProfileName'],'$this->heizungssteuerung["createHeizplanConstants"]["iFrontVariableProfileName"]');
	 	foreach ($this->heizungssteuerung['rootNodesHeizplan'] as $key => $value) {$this->checkObjectIDExists("category",$value,'$this->heizungssteuerung["rootNodesHeizplan"]['. $key ."]");}
	 	foreach ($this->heizungssteuerung['readRaumSollTemeratur'] as $key => $value) {$this->checkObjectIDExists("variable",$value,'$this->heizungssteuerung["readRaumSollTemeratur"]['. $key ."]");}
		// Wird die Raum-Temperatur auf ein Objeckt oder eine IPS Variable geschrieben (je nach Interface)?
		$actualObjectType = "";
		if ($this->getHeizungsInterface() == "sendeHeizenFloatTemperatur" ) {$actualObjectType = "object";}
		if ($this->getHeizungsInterface() == "sendeHeizenFloatTemperatur6und30Grad") {$actualObjectType = "object";}
		if ($this->getHeizungsInterface() == "sendeHeizenBooleanJaNein" ) {$actualObjectType = "variable";}
		foreach ($this->heizungssteuerung['writeRaumSollTemeratur'] as $key => $value) {$this->checkObjectIDExists($actualObjectType,$value,'$this->heizungssteuerung["writeRaumSollTemeratur"]['. $key ."]");}
		$actualObjectType = "";
		foreach ($this->heizungssteuerung['readRaumIstTemeratur'] as $key => $value) {$this->checkObjectIDExists("variable",$value,'$this->heizungssteuerung["readRaumIstTemeratur"]['. $key ."]");}

		// $this->heizungssteuerung['heizStatiRaeume'] nur checken, wenn das Interface HomeMaticHeizenJaNein oder EinsWireWago ist
		// fr HomeMatic werden die Variablen nicht bentigt
		if ($this->heizungssteuerung['heizungsInterface'] == "sendeHeizenBooleanJaNein"
		   || $this->heizungssteuerung['heizungsInterface'] == "sendeHeizenFloatTemperatur6und30Grad") {

			// $this->heizungssteuerung['heizungsKomponenten'] = "HomeMaticKomponenten";
			foreach ($this->heizungssteuerung['heizStatiRaeume'] as $key => $value) {$this->checkObjectIDExists("variable",$value,'$this->heizungssteuerung["heizStatiRaeume"]['. $key ."]");}
			}

		foreach ($this->heizungssteuerung['rootNodesFenster'] as $key => $value) {
			foreach ($this->heizungssteuerung['rootNodesFenster'][$key] as $key1 => $value1) {
				$this->checkObjectIDExists("variable",$value1,'$this->heizungssteuerung["rootNodesFenster"]['. $key ."][". $key1 ."]");
				}
			}
		foreach ($this->heizungssteuerung['temperaturProfile'] as $key => $value) {
			foreach ($this->heizungssteuerung['temperaturProfile'][$key] as $key1 => $value1) {
				$this->checkObjectIDExists("variable",$value1,'$this->heizungssteuerung["temperaturProfile"]['. $key ."][". $key1 ."]");
				}
			}
	 }
	 
	public function checkObjectIDExists($objectType,$objectID,$objectName) {

		$this->showEnvironmentDebugMessage('check existens of Variable Number '. $objectID .' ('. $objectType .' / '. $objectName .')' ,"config.class[checkObjectIDExists]",1);

	   $objectExists = FALSE;
		if ($objectType == "variable") {$objectExists = IPS_VariableExists($objectID);}
		if ($objectType == "script") {$objectExists = IPS_ScriptExists($objectID);}
		if ($objectType == "category") {$objectExists = IPS_CategoryExists($objectID);}
		if ($objectType == "variableProfile") {$objectExists = IPS_VariableProfileExists($objectID);}
		if ($objectType == "object") {$objectExists = IPS_ObjectExists($objectID);}

      if (!$objectExists) {
			if ($objectType == "") {
				$this->showEnvironmentDebugMessage("FEHLER: Das in der config-Datei definierte Object mit der Nummer ". $objectID . " besitzt KEINEN Type ==> Abbruch des Scripts (". $objectName .")" ,"config.class[checkObjectIDExists]",1);
				IPS_LogMessage("config.class","FEHLER: Das in der config-Datei definierte Object mit der Nummer ". $objectID . " besitzt KEINEN Type \n==> Abbruch des Scripts (". $objectName .")");
				}
			else {
				$this->showEnvironmentDebugMessage("FEHLER: Das in der config-Datei definierte Object mit der Nummer ". $objectID . " existiert NICHT ==> Abbruch des Scripts (". $objectType ." / ". $objectName .")" ,"config.class[checkObjectIDExists]",1);
				IPS_LogMessage("config.class","FEHLER: Das in der config-Datei definierte Object mit der Nummer ". $objectID . " existiert NICHT \n==> Abbruch des Scripts (". $objectType ." / ". $objectName .")");
				}
			die(-1);
			}
		return 1;
		}

	public function showEnvironmentDebugMessage ($message, $debugCategorie, $debugCount) {
		// delegate call
		$this->environmentDebugConfigObject->showEnvironmentDebugMessage($message, $debugCategorie, $debugCount);
	}

	 public function showDebugMessage ($message) {
	 // Dummy Methode, da tatsaechliche Ausgaben ueber showEnvironmentDebugMessage ausgegeben werden sollten
	 // TODO: EXCEPTION werfen
	 }


}

//Fgen Sie hier ihren Skriptquellcode ein

?>